---
title: IDBEnvironment
slug: Web/API/IDBEnvironment
tags:
  - API
  - DOM
  - Database
  - IDBEnvironment
  - IndexedDB
  - Interface
  - Obsolete
  - Reference
  - Référence(2)
  - Storage
  - access
  - asynchronous
  - client-side
---
<p>{{APIRef()}}{{obsolete_header}}</p>

<div class="warning">
<p><strong>Important</strong>: The <code>indexedDB</code> property that was previously defined in this mixin is instead now {{domxref("WindowOrWorkerGlobalScope.indexedDB")}} (that is, defined as a member of the {{domxref("WindowOrWorkerGlobalScope")}} mixin).</p>
</div>

<p>The <strong><code>IDBEnvironment</code></strong> helper of the <a href="/en-US/docs/IndexedDB">IndexedDB API</a> contains the <code>indexedDB</code> property, which provides access to IndexedDB functionality. It is the top level IndexedDB interface implemented by the {{domxref("window")}} and {{domxref("Worker")}} objects.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("IDBEnvironment.indexedDB")}} {{readonlyInline}}</dt>
 <dd>Provides a mechanism for applications to asynchronously access capabilities of indexed databases; contains an {{domxref("IDBFactory")}} object.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following code creates a request for a database to be opened asychronously, after which the database is opened when the request's <code>onsuccess</code> handler is fired:</p>

<pre class="brush: js;highlight:[3]">var db;
function openDB() {
 var DBOpenRequest = window.indexedDB.open("toDoList");
 DBOpenRequest.onsuccess = function(e) {
   db = DBOpenRequest.result;
 };
}
</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBEnvironment")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
